\documentclass[a4paper]{article}
\usepackage[english]{babel}
\usepackage[T1]{fontenc}
\usepackage[a4paper, top=0.75cm, bottom=0.75cm, left=2cm, right=2cm]{geometry}
\usepackage{listings}
\usepackage{inconsolata}
\pagenumbering{gobble}
\lstset{frame=single, showstringspaces=false, columns=fixed, basicstyle={\ttfamily}, commentstyle={\it}, numbers=left, tabsize=4}
\begin{document}
\lstset{title=Contents of \texttt{README}}
\lstset{
  language=,
  morekeywords={NAME, SYNOPSIS, DESCRIPTION, NOTES, EXAMPLES, AUTHOR, COPYRIGHT},
  moredelim=[is][\it]{<|}{|>},
  moredelim=[is][\bf]{<:}{:>}
}
\begin{lstlisting}
NAME
        <:pipeline:> - create a chain of processes with standard input and output
            redirection. The resulting execution should be equivalent to
            a shell command of the form
                <|P1|> < <|X|> | <|P2|> | ... | <|PN|>-<|1|> | <|PN|> > <|Y|>
            Where <|P|>(i) are the names of programs, valid for execlp,
            <|X|> and <|Y|> are the input and output file descriptors.

SYNOPSIS
        void <:pipeline:>(<|Pipe|> io, const char *cmd, ...);
            Create a chain of processes, with io.r = <|X|> and io.w = <|Y|>.
            Following arguments specify the strings for program names to run.
            The list of strings should contain 1 or more non-NULL elements and
            be terminated with NULL.
        void <:spawn:>(<|Pipe|> inp, <|Pipe|> out, const char *cmd);
            Create a single process which reads from inp and writes to out.
            The process is specified by cmd. See execlp(3) for details.
        <|Pipe|> <:mkPipe:>(void);
            Create a <|Pipe|> object, suitable for use with pipeline/spawn.


EXAMPLES
        An example usage, implementing a shell command of the form
            <|P1|> < <|X|> | <|P2|> > <|Y|>
        can be found in src/examples.c

NOTES
        Please note, that pipeline expects the file descriptors passed to it in
        io to have the close-on-exec flag enabled and closes them upon
        successful execution.

AUTHOR
        Implemented by Stotskii Andrey (ruro).

COPYRIGHT
        Copyright (c) 2017 Free Software Foundation, Inc.  License GPLv3+:
        GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>.
        This is free software: you are free to change and redistribute it.
        There is NO WARRANTY, to the extent permitted by law.
\end{lstlisting}
\lstset{title=Contents of \texttt{makefile}}
\lstset{language={[gnu]make}}
\begin{lstlisting}
CFLAGS= -Wall -O3 -std=gnu99
LDFLAGS= -s -lm -lpthread
CC=gcc

vpath %.c src
vpath %.h src

examples:   pipeline.h terminator.h pipeline.o terminator.o forkshare.o
pipeline.o: pipeline.h terminator.h
terminator.o:          terminator.h forkshare.h
forkshare.o:           terminator.h forkshare.h

.PHONY:libs
libs: pipeline.o terminator.o forkshare.o

.PHONY:clean
clean:
	rm -f *.o examples
\end{lstlisting}
\newpage
\lstset{language={[ANSI]C}}
\lstset{literate={float.}{float.}6}
\lstset{morekeywords={size_t, ssize_t, bool, pid_t, func, sem_t, Pipe, Task, TaskStream, Worker, Swarm}}
\lstset{moredelim=[s][\it]{__}{__}}
\lstset{moredelim=[s][\it]{((}{))}}
\lstset{title=Contents of \texttt{src/pipeline.h}}
\begin{lstlisting}
#ifndef _PIPELINE_H
#define _PIPELINE_H

typedef struct {
    int r;
    int w;
} Pipe;

Pipe mkPipe(void);
void spawn(Pipe, Pipe, const char *) __attribute__ (( nonnull ));
void pipeline(Pipe, const char *, ...)
    __attribute__ (( nonnull(2) ))
    __attribute__ (( sentinel ));

#endif
\end{lstlisting}
\lstset{title=Contents of \texttt{src/pipeline.c}}
\begin{lstlisting}
#include <errno.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdarg.h>
#include <fcntl.h>

#include "pipeline.h"
#include "terminator.h"

Pipe mkPipe(void)
{
    // Create the pipe.
    int fd[2];
    if (pipe(fd))
        terminate(errno, "Couldn't spawn a pipe.\n");
    // Make it close on exec.
    if (fcntl(fd[0], F_SETFD, FD_CLOEXEC) == -1 ||
        fcntl(fd[1], F_SETFD, FD_CLOEXEC) == -1)
        terminate(errno, "Couldn't enable close-on-exec for pipe.\n");
    // Make the Pipe object.
    Pipe ret = { .r = fd[0], .w = fd[1] };
    return ret;
}

void spawn(Pipe i, Pipe o, const char *cmd)
{
    pid_t p = fork();
    if (p == -1)
        terminate(errno, "Couldn't fork.\n");
    // Child.
    if (!p)
    {
        // Change stdin and stdout to ends of io Pipe.
        if (dup2(i.r, STDIN_FILENO) == -1 ||
            dup2(o.w, STDOUT_FILENO) == -1)
            terminate(errno, "Couldn't replace IO with with pipe.\n");

        // Run command.
        if (execlp(cmd, cmd, NULL))
            terminate(errno, "Couldn't run command %s.\n", cmd);
    }
}

\end{lstlisting}
\newpage
\begin{lstlisting}[firstnumber=last]
void pipeline(Pipe ends, const char *proc, ...)
{
    Pipe next, prev = ends;
    va_list cmds;
    const char *cmd;

    // For every argument:
    va_start(cmds, proc);
    while ( (cmd = va_arg(cmds, const char *)) )
    {
        // Run a command in new process.
        next = mkPipe();
        spawn(prev, next, proc);

        // Adjust pipes for next process.
        if (close(prev.r) || close(next.w))
            terminate(errno, "Couldn't close pipe end.\n");
        prev = next;
        proc = cmd;
    }
    va_end(cmds);

    // Run last process.
    spawn(prev, ends, proc);

    // Clean up.
    close(prev.r);
    close(ends.w);
}
\end{lstlisting}
\lstset{title=Contents of \texttt{src/examples.c}}
\begin{lstlisting}
#include <unistd.h>
#include <errno.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>

#include "pipeline.h"
#include "terminator.h"

#define S_IRWA S_IRUSR | S_IWUSR | S_IRGRP | S_IWGRP | S_IROTH | S_IWOTH

int main(int argc, char *argv[])
{
    // Make terminator IO atomic.
    atomize();

    // Open input and output files.
    int inp = open(argv[2], O_RDONLY | O_CLOEXEC);
    if (inp == -1)
        terminate(errno, "Couldn't open file %s.\n", argv[2]);

    int out = open(argv[4], O_WRONLY | O_CREAT | O_CLOEXEC | O_TRUNC, S_IRWA);
    if (out == -1)
        terminate(errno, "Couldn't open file %s.\n", argv[4]);

    // X < A | Y > B
    Pipe io = {.r = inp, .w = out};
    pipeline(io, argv[1], argv[3], NULL);

    // Wait for children to die.
    while (wait(NULL) != -1);
}
\end{lstlisting}
\end{document}
